diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-phy.h ns-3.43/src/wifi/model/wifi-phy.h
--- ns-3.42/src/wifi/model/wifi-phy.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-phy.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
@@ -55,6 +44,7 @@
 class UniformRandomVariable;
 class InterferenceHelper;
 class ErrorRateModel;
+class WifiMacHeader;
 
 /**
  * \brief 802.11 PHY layer model
@@ -96,7 +86,7 @@
      * \param listener the new listener
      *
      * Add the input listener to the list of objects to be notified of
-     * PHY-level events.
+     * PHY-level events. The input listener is notified of CCA busy information.
      */
     void RegisterListener(const std::shared_ptr<WifiPhyListener>& listener);
     /**
@@ -166,7 +156,7 @@
      * real transmission power is calculated as txPowerMin + txPowerLevel * (txPowerMax -
      * txPowerMin) / nTxLevels
      */
-    void Send(WifiConstPsduMap psdus, const WifiTxVector& txVector);
+    void Send(const WifiConstPsduMap& psdus, const WifiTxVector& txVector);
 
     /**
      * \param ppdu the PPDU to send
@@ -276,7 +266,7 @@
      *
      * \return the total amount of time this PHY will stay busy for the transmission of the PPDU
      */
-    static Time CalculateTxDuration(WifiConstPsduMap psduMap,
+    static Time CalculateTxDuration(const WifiConstPsduMap& psduMap,
                                     const WifiTxVector& txVector,
                                     WifiPhyBand band);
 
@@ -572,16 +562,16 @@
      * Implemented for encapsulation purposes.
      *
      * \param psdus the PSDUs being transmitted (only one unless DL MU transmission)
-     * \param txPowerW the transmit power in Watts
+     * \param txPower the transmit power
      */
-    void NotifyTxBegin(WifiConstPsduMap psdus, double txPowerW);
+    void NotifyTxBegin(const WifiConstPsduMap& psdus, Watt_u txPower);
     /**
      * Public method used to fire a PhyTxEnd trace.
      * Implemented for encapsulation purposes.
      *
      * \param psdus the PSDUs being transmitted (only one unless DL MU transmission)
      */
-    void NotifyTxEnd(WifiConstPsduMap psdus);
+    void NotifyTxEnd(const WifiConstPsduMap& psdus);
     /**
      * Public method used to fire a PhyTxDrop trace.
      * Implemented for encapsulation purposes.
@@ -635,13 +625,11 @@
      * for each A-MPDU but the same for each subframe within one A-MPDU.
      *
      * \param psdu the PSDU being received
-     * \param channelFreqMhz the frequency in MHz at which the packet is
-     *        received. Note that in real devices this is normally the
-     *        frequency to which  the receiver is tuned, and this can be
-     *        different than the frequency at which the packet was originally
-     *        transmitted. This is because it is possible to have the receiver
-     *        tuned on a given channel and still to be able to receive packets
-     *        on a nearby channel.
+     * \param channelFreq the frequency at which the packet is received. Note that in real devices
+     * this is normally the frequency to which the receiver is tuned, and this can be different than
+     * the frequency at which the packet was originally transmitted. This is because it is possible
+     * to have the receiver tuned on a given channel and still to be able to receive packets on a
+     * nearby channel.
      * \param txVector the TXVECTOR that holds RX parameters
      * \param signalNoise signal power and noise power in dBm (noise power includes the noise
      * figure)
@@ -649,7 +637,7 @@
      * \param staId the STA-ID
      */
     void NotifyMonitorSniffRx(Ptr<const WifiPsdu> psdu,
-                              uint16_t channelFreqMhz,
+                              MHz_u channelFreq,
                               WifiTxVector txVector,
                               SignalNoiseDbm signalNoise,
                               std::vector<bool> statusPerMpdu,
@@ -660,13 +648,11 @@
      *
      *
      * \param packet the packet being received
-     * \param channelFreqMhz the frequency in MHz at which the packet is
-     *        received. Note that in real devices this is normally the
-     *        frequency to which  the receiver is tuned, and this can be
-     *        different than the frequency at which the packet was originally
-     *        transmitted. This is because it is possible to have the receiver
-     *        tuned on a given channel and still to be able to receive packets
-     *        on a nearby channel.
+     * \param channelFreq the frequency at which the packet is received. Note that in real devices
+     * this is normally the frequency to which  the receiver is tuned, and this can be different
+     * than the frequency at which the packet was originally transmitted. This is because it is
+     * possible to have the receiver tuned on a given channel and still to be able to receive
+     * packets on a nearby channel.
      * \param txVector the TXVECTOR that holds RX parameters
      * \param aMpdu the type of the packet (0 is not A-MPDU, 1 is a MPDU that is part of an A-MPDU
      * and 2 is the last MPDU in an A-MPDU) and the A-MPDU reference number (must be a different
@@ -691,13 +677,13 @@
      * for each A-MPDU but the same for each subframe within one A-MPDU.
      *
      * \param psdu the PSDU being received
-     * \param channelFreqMhz the frequency in MHz at which the packet is
+     * \param channelFreq the frequency at which the packet is
      *        transmitted.
      * \param txVector the TXVECTOR that holds TX parameters
      * \param staId the STA-ID
      */
     void NotifyMonitorSniffTx(Ptr<const WifiPsdu> psdu,
-                              uint16_t channelFreqMhz,
+                              MHz_u channelFreq,
                               WifiTxVector txVector,
                               uint16_t staId = SU_STA_ID);
 
@@ -767,6 +753,17 @@
                                                 WifiPhyRxfailureReason reason);
 
     /**
+     * TracedCallback signature for end of MAC header reception events.
+     *
+     * \param macHdr the MAC header of the MPDU being received
+     * \param txVector the TXVECTOR used to transmit the PSDU
+     * \param psduDuration the remaining duration of the PSDU
+     */
+    typedef void (*PhyRxMacHeaderEndTracedCallback)(const WifiMacHeader& macHdr,
+                                                    const WifiTxVector& txVector,
+                                                    Time psduDuration);
+
+    /**
      * Assign a fixed random variable stream number to the random variables
      * used by this model. Return the number of streams (possibly zero) that
      * have been assigned.
@@ -777,75 +774,75 @@
     virtual int64_t AssignStreams(int64_t stream);
 
     /**
-     * Sets the receive sensitivity threshold (dBm).
+     * Sets the receive sensitivity threshold.
      * The energy of a received signal should be higher than
      * this threshold to allow the PHY layer to detect the signal.
      *
-     * \param threshold the receive sensitivity threshold in dBm
+     * \param threshold the receive sensitivity threshold
      */
-    void SetRxSensitivity(double threshold);
+    void SetRxSensitivity(dBm_u threshold);
     /**
-     * Return the receive sensitivity threshold (dBm).
+     * Return the receive sensitivity threshold.
      *
-     * \return the receive sensitivity threshold in dBm
+     * \return the receive sensitivity threshold
      */
-    double GetRxSensitivity() const;
+    dBm_u GetRxSensitivity() const;
     /**
-     * Sets the CCA energy detection threshold (dBm). The energy of a all received signals
+     * Sets the CCA energy detection threshold. The energy of a all received signals
      * should be higher than this threshold to allow the PHY layer to declare CCA BUSY state.
      *
-     * \param threshold the CCA threshold in dBm
+     * \param threshold the CCA threshold
      */
-    void SetCcaEdThreshold(double threshold);
+    void SetCcaEdThreshold(dBm_u threshold);
     /**
-     * Return the CCA energy detection threshold (dBm).
+     * Return the CCA energy detection threshold.
      *
-     * \return the CCA energy detection threshold in dBm
+     * \return the CCA energy detection threshold
      */
-    double GetCcaEdThreshold() const;
+    dBm_u GetCcaEdThreshold() const;
     /**
-     * Sets the CCA sensitivity threshold (dBm). The energy of a received wifi signal
+     * Sets the CCA sensitivity threshold. The energy of a received wifi signal
      * should be higher than this threshold to allow the PHY layer to declare CCA BUSY state.
      *
-     * \param threshold the CCA sensitivity threshold in dBm
+     * \param threshold the CCA sensitivity threshold
      */
-    void SetCcaSensitivityThreshold(double threshold);
+    void SetCcaSensitivityThreshold(dBm_u threshold);
     /**
-     * Return the CCA sensitivity threshold (dBm).
+     * Return the CCA sensitivity threshold.
      *
-     * \return the CCA sensitivity threshold in dBm
+     * \return the CCA sensitivity threshold
      */
-    double GetCcaSensitivityThreshold() const;
+    dBm_u GetCcaSensitivityThreshold() const;
     /**
-     * Sets the RX loss (dB) in the Signal-to-Noise-Ratio due to non-idealities in the receiver.
+     * Sets the RX loss in the Signal-to-Noise-Ratio due to non-idealities in the receiver.
      *
-     * \param noiseFigureDb noise figure in dB
+     * \param noiseFigure noise figure
      */
-    void SetRxNoiseFigure(double noiseFigureDb);
+    void SetRxNoiseFigure(dB_u noiseFigure);
     /**
-     * Sets the minimum available transmission power level (dBm).
+     * Sets the minimum available transmission power level.
      *
-     * \param start the minimum transmission power level (dBm)
+     * \param start the minimum transmission power level
      */
-    void SetTxPowerStart(double start);
+    void SetTxPowerStart(dBm_u start);
     /**
-     * Return the minimum available transmission power level (dBm).
+     * Return the minimum available transmission power level.
      *
-     * \return the minimum available transmission power level (dBm)
+     * \return the minimum available transmission power level
      */
-    double GetTxPowerStart() const;
+    dBm_u GetTxPowerStart() const;
     /**
-     * Sets the maximum available transmission power level (dBm).
+     * Sets the maximum available transmission power level.
      *
-     * \param end the maximum transmission power level (dBm)
+     * \param end the maximum transmission power level
      */
-    void SetTxPowerEnd(double end);
+    void SetTxPowerEnd(dBm_u end);
     /**
-     * Return the maximum available transmission power level (dBm).
+     * Return the maximum available transmission power level.
      *
-     * \return the maximum available transmission power level (dBm)
+     * \return the maximum available transmission power level
      */
-    double GetTxPowerEnd() const;
+    dBm_u GetTxPowerEnd() const;
     /**
      * Sets the number of transmission power levels available between the
      * minimum level and the maximum level. Transmission power levels are
@@ -861,29 +858,29 @@
      */
     uint8_t GetNTxPower() const;
     /**
-     * Sets the transmission gain (dB).
+     * Sets the transmission gain.
      *
-     * \param gain the transmission gain in dB
+     * \param gain the transmission gain
      */
-    void SetTxGain(double gain);
+    void SetTxGain(dB_u gain);
     /**
-     * Return the transmission gain (dB).
+     * Return the transmission gain.
      *
-     * \return the transmission gain in dB
+     * \return the transmission gain
      */
-    double GetTxGain() const;
+    dB_u GetTxGain() const;
     /**
-     * Sets the reception gain (dB).
+     * Sets the reception gain.
      *
-     * \param gain the reception gain in dB
+     * \param gain the reception gain
      */
-    void SetRxGain(double gain);
+    void SetRxGain(dB_u gain);
     /**
-     * Return the reception gain (dB).
+     * Return the reception gain.
      *
-     * \return the reception gain in dB
+     * \return the reception gain
      */
-    double GetRxGain() const;
+    dB_u GetRxGain() const;
 
     /**
      * Sets the device this PHY is associated with.
@@ -919,26 +916,15 @@
      */
     Ptr<MobilityModel> GetMobility() const;
 
-    using ChannelTuple =
-        std::tuple<uint8_t /* channel number */,
-                   uint16_t /* channel width */,
-                   WifiPhyBand /* WifiPhyBand */,
-                   uint8_t /* primary20 index*/>; //!< Tuple identifying an operating channel
+    using ChannelTuple = std::tuple<uint8_t /* channel number */,
+                                    MHz_u /* channel width */,
+                                    WifiPhyBand /* WifiPhyBand */,
+                                    uint8_t /* primary20 index*/>; //!< Tuple identifying a segment
+                                                                   //!< of an operating channel
+
+    using ChannelSegments =
+        std::vector<ChannelTuple>; //!< segments identifying an operating channel
 
-    /**
-     * If the standard for this object has not been set yet, store the given channel
-     * settings. Otherwise, check if a channel switch can be performed now. If not,
-     * schedule another call to this method when channel switch can be performed.
-     * Otherwise, set the operating channel based on the given channel settings and
-     * call ConfigureStandard if the PHY band has changed.
-     *
-     * Note that, in case a Spectrum PHY is used, a spectrum channel covering the
-     * operating channel bandwidth must have been already added when actually setting
-     * the operating channel.
-     *
-     * \param channelTuple the given channel settings
-     */
-    void SetOperatingChannel(const ChannelTuple& channelTuple);
     /**
      * If the standard for this object has not been set yet, store the channel settings
      * corresponding to the given operating channel. Otherwise, check if a channel switch
@@ -953,6 +939,23 @@
      * \param channel the given operating channel
      */
     void SetOperatingChannel(const WifiPhyOperatingChannel& channel);
+
+    /**
+     * This overloaded function is used to pass a list of segments
+     * from which the operating channel can be deduced.
+     *
+     * \param channelSegments the segments identifying the operating channel
+     */
+    void SetOperatingChannel(const ChannelSegments& channelSegments);
+
+    /**
+     * This overloaded function is used when the operating channel
+     * consists of a single segment, identified by a tuple.
+     *
+     * \param tuple the segment identifying the operating channel
+     */
+    void SetOperatingChannel(const ChannelTuple& tuple);
+
     /**
      * Configure whether it is prohibited to change PHY band after initialization.
      *
@@ -965,9 +968,9 @@
      */
     bool HasFixedPhyBand() const;
     /**
-     * \return the operating center frequency (MHz)
+     * \return the operating center frequency
      */
-    uint16_t GetFrequency() const;
+    MHz_u GetFrequency() const;
     /**
      * \return the index of the primary 20 MHz channel
      */
@@ -981,9 +984,8 @@
      * \param maxAllowedBandWidth the maximum allowed TX bandwidth
      * \return the bandwidth for the transmission
      */
-    uint16_t GetTxBandwidth(
-        WifiMode mode,
-        uint16_t maxAllowedBandWidth = std::numeric_limits<uint16_t>::max()) const;
+    MHz_u GetTxBandwidth(WifiMode mode,
+                         MHz_u maxAllowedBandWidth = std::numeric_limits<MHz_u>::max()) const;
     /**
      * \param antennas the number of antennas on this node.
      */
@@ -1080,38 +1082,38 @@
     void SetWifiRadioEnergyModel(const Ptr<WifiRadioEnergyModel> wifiRadioEnergyModel);
 
     /**
-     * \return the channel width in MHz
+     * \return the channel width
      */
-    uint16_t GetChannelWidth() const;
+    MHz_u GetChannelWidth() const;
 
     /**
-     * Get the power of the given power level in dBm.
-     * In SpectrumWifiPhy implementation, the power levels are equally spaced (in dBm).
+     * Get the power of the given power level.
+     * In current implementation, the power levels are equally spaced (in dBm).
      *
-     * \param power the power level
+     * \param powerLevel the power level
      *
-     * \return the transmission power in dBm at the given power level
+     * \return the transmission power at the given power level
      */
-    double GetPowerDbm(uint8_t power) const;
+    dBm_u GetPower(uint8_t powerLevel) const;
 
     /**
      * Reset PHY to IDLE, with some potential TX power restrictions for the next transmission.
      *
      * \param powerRestricted flag whether the transmit power is restricted for the next
      * transmission
-     * \param txPowerMaxSiso the SISO transmit power restriction for the next transmission in dBm
-     * \param txPowerMaxMimo the MIMO transmit power restriction for the next transmission in dBm
+     * \param txPowerMaxSiso the SISO transmit power restriction for the next transmission
+     * \param txPowerMaxMimo the MIMO transmit power restriction for the next transmission
      */
-    void ResetCca(bool powerRestricted, double txPowerMaxSiso = 0, double txPowerMaxMimo = 0);
+    void ResetCca(bool powerRestricted, dBm_u txPowerMaxSiso = 0, dBm_u txPowerMaxMimo = 0);
     /**
      * Compute the transmit power for the next transmission.
      * The returned power will satisfy the power density constraints
      * after addition of antenna gain.
      *
      * \param ppdu the PPDU to transmit
-     * \return the transmit power in dBm for the next transmission
+     * \return the transmit power for the next transmission
      */
-    double GetTxPowerForTransmission(Ptr<const WifiPpdu> ppdu) const;
+    dBm_u GetTxPowerForTransmission(Ptr<const WifiPpdu> ppdu) const;
     /**
      * Notify the PHY that an access to the channel was requested.
      * This is typically called by the channel access manager to
@@ -1203,8 +1205,8 @@
     void SetPreviouslyRxPpduUid(uint64_t uid);
 
     /**
-     * \param currentChannelWidth channel width of the current transmission (MHz)
-     * \return the width of the guard band (MHz)
+     * \param currentChannelWidth channel width of the current transmission
+     * \return the width of the guard band
      *
      * Note: in order to properly model out of band transmissions for OFDM, the guard
      * band has been configured so as to expand the modeled spectrum up to the
@@ -1215,34 +1217,34 @@
      *
      * This method is only relevant for SpectrumWifiPhy.
      */
-    virtual uint16_t GetGuardBandwidth(uint16_t currentChannelWidth) const = 0;
+    virtual MHz_u GetGuardBandwidth(MHz_u currentChannelWidth) const = 0;
     /**
-     * \return a tuple containing the minimum rejection (in dBr) for the inner band,
-     *                            the minimum rejection (in dBr) for the outer band, and
-     *                            the maximum rejection (in dBr) for the outer band
+     * \return a tuple containing the minimum rejection for the inner band,
+     *                            the minimum rejection for the outer band, and
+     *                            the maximum rejection for the outer band
      *                            for the transmit spectrum mask.
      *
      * This method is only relevant for SpectrumWifiPhy.
      */
-    virtual std::tuple<double, double, double> GetTxMaskRejectionParams() const = 0;
+    virtual std::tuple<dBr_u, dBr_u, dBr_u> GetTxMaskRejectionParams() const = 0;
 
     /**
      * Get channel number of the primary channel
-     * \param primaryChannelWidth the width of the primary channel (MHz)
+     * \param primaryChannelWidth the width of the primary channel
      *
      * \return channel number of the primary channel
      */
-    uint8_t GetPrimaryChannelNumber(uint16_t primaryChannelWidth) const;
+    uint8_t GetPrimaryChannelNumber(MHz_u primaryChannelWidth) const;
 
     /**
      * Get the info of a given band
      *
-     * \param bandWidth the width of the band to be returned (MHz)
+     * \param bandWidth the width of the band to be returned
      * \param bandIndex the index of the band to be returned
      *
      * \return the info that defines the band
      */
-    virtual WifiSpectrumBandInfo GetBand(uint16_t bandWidth, uint8_t bandIndex = 0) = 0;
+    virtual WifiSpectrumBandInfo GetBand(MHz_u bandWidth, uint8_t bandIndex = 0) = 0;
 
     /**
      * Get the frequency range of the current RF interface.
@@ -1252,9 +1254,9 @@
     virtual FrequencyRange GetCurrentFrequencyRange() const = 0;
 
     /**
-     * \return the subcarrier spacing corresponding to the configure standard (Hz)
+     * \return the subcarrier spacing corresponding to the configure standard
      */
-    uint32_t GetSubcarrierSpacing() const;
+    Hz_u GetSubcarrierSpacing() const;
 
     /**
      * Callback invoked when the PHY model starts to transmit a signal
@@ -1439,6 +1441,12 @@
     Ptr<const WifiPsdu> GetAddressedPsduInPpdu(Ptr<const WifiPpdu> ppdu) const;
 
     /**
+     * Method that can be overridden by subclasses to perform operations after the channel is
+     * actually switched but before the MAC is notified of the channel switch.
+     */
+    virtual void FinalizeChannelSwitch() = 0;
+
+    /**
      * The trace source fired when a packet begins the transmission process on
      * the medium.
      *
@@ -1494,6 +1502,17 @@
     TracedCallback<WifiTxVector, Time> m_phyRxPayloadBeginTrace;
 
     /**
+     * The trace source fired when the reception of a MAC header ends.
+     *
+     * This traced callback models the behavior of real PHYs that are able to decode the MAC
+     * header of an MPDU being received and make the information therein available to the MAC
+     * as soon as the reception of the MAC header ends.
+     *
+     * \see class CallBackTraceSource
+     */
+    TracedCallback<const WifiMacHeader&, const WifiTxVector&, Time> m_phyRxMacHeaderEndTrace;
+
+    /**
      * The trace source fired when a packet ends the reception process from
      * the medium.
      *
@@ -1564,7 +1583,7 @@
     WifiStandard m_standard;                    //!< WifiStandard
     WifiModulationClass m_maxModClassSupported; //!< max modulation class supported
     WifiPhyBand m_band;                         //!< WifiPhyBand
-    ChannelTuple m_channelSettings; //!< Store operating channel settings until initialization
+    ChannelSegments m_channelSettings; //!< Store operating channel settings until initialization
     WifiPhyOperatingChannel m_operatingChannel; //!< Operating channel
     bool m_fixedPhyBand; //!< True to prohibit changing PHY band after initialization
 
@@ -1574,24 +1593,21 @@
     Time m_ackTxTime;      //!< estimated Ack TX time
     Time m_blockAckTxTime; //!< estimated BlockAck TX time
 
-    double m_rxSensitivityDbm; //!< Receive sensitivity threshold in dBm
-    double m_ccaEdThresholdW; //!< Clear channel assessment (CCA) energy detection (ED) threshold in
-                              //!< watts
-    double m_ccaSensitivityThresholdW; //!< Clear channel assessment (CCA) modulation and coding
-                                       //!< rate sensitivity threshold in watts
-
-    double m_txGainDb;          //!< Transmission gain (dB)
-    double m_rxGainDb;          //!< Reception gain (dB)
-    double m_txPowerBaseDbm;    //!< Minimum transmission power (dBm)
-    double m_txPowerEndDbm;     //!< Maximum transmission power (dBm)
-    uint8_t m_nTxPower;         //!< Number of available transmission power levels
-    double m_powerDensityLimit; //!< the power density limit (dBm/MHz)
+    dBm_u m_rxSensitivity;  //!< Receive sensitivity threshold
+    dBm_u m_ccaEdThreshold; //!< Clear channel assessment (CCA) energy detection (ED) threshold
+    dBm_u m_ccaSensitivityThreshold; //!< Clear channel assessment (CCA) modulation and coding rate
+                                     //!< sensitivity threshold
+
+    dB_u m_txGain;                     //!< Transmission gain
+    dB_u m_rxGain;                     //!< Reception gain
+    dBm_u m_txPowerBase;               //!< Minimum transmission power
+    dBm_u m_txPowerEnd;                //!< Maximum transmission power
+    uint8_t m_nTxPower;                //!< Number of available transmission power levels
+    dBm_per_MHz_u m_powerDensityLimit; //!< the power density limit
 
     bool m_powerRestricted; //!< Flag whether transmit power is restricted by OBSS PD SR
-    double
-        m_txPowerMaxSiso; //!< SISO maximum transmit power due to OBSS PD SR power restriction (dBm)
-    double
-        m_txPowerMaxMimo; //!< MIMO maximum transmit power due to OBSS PD SR power restriction (dBm)
+    dBm_u m_txPowerMaxSiso; //!< SISO maximum transmit power due to OBSS PD SR power restriction
+    dBm_u m_txPowerMaxMimo; //!< MIMO maximum transmit power due to OBSS PD SR power restriction
     bool m_channelAccessRequested; //!< Flag if channels access has been requested (used for OBSS_PD
                                    //!< SR)
 
@@ -1600,7 +1616,7 @@
     uint8_t m_txSpatialStreams; //!< Number of supported TX spatial streams
     uint8_t m_rxSpatialStreams; //!< Number of supported RX spatial streams
 
-    double m_noiseFigureDb; //!< The noise figure in dB
+    dB_u m_noiseFigure; //!< The noise figure
 
     Time m_channelSwitchDelay; //!< Time required to switch between channel
 
@@ -1612,6 +1628,7 @@
     Ptr<WifiRadioEnergyModel> m_wifiRadioEnergyModel;     //!< Wifi radio energy model
     Ptr<ErrorModel> m_postReceptionErrorModel;            //!< Error model for receive packet events
     Time m_timeLastPreambleDetected; //!< Record the time the last preamble was detected
+    bool m_notifyRxMacHeaderEnd;     //!< whether the PHY is capable of notifying MAC header RX end
 
     Callback<void> m_capabilitiesChangedCallback; //!< Callback when PHY capabilities changed
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-phy-listener.h ns-3.43/src/wifi/model/wifi-phy-listener.h
--- ns-3.42/src/wifi/model/wifi-phy-listener.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-phy-listener.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
@@ -69,7 +58,7 @@
     virtual void NotifyRxEndError() = 0;
     /**
      * \param duration the expected transmission duration.
-     * \param txPowerDbm the nominal TX power in dBm
+     * \param txPower the nominal TX power
      *
      * We are about to send the first bit of the packet.
      * We do not send any event to notify the end of
@@ -77,7 +66,7 @@
      * channel implicitly reverts to the idle state
      * unless they have received a CCA busy report.
      */
-    virtual void NotifyTxStart(Time duration, double txPowerDbm) = 0;
+    virtual void NotifyTxStart(Time duration, dBm_u txPower) = 0;
     /**
      * \param duration the expected busy duration.
      * \param channelType the channel type for which the CCA busy state is reported.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-phy-operating-channel.cc ns-3.43/src/wifi/model/wifi-phy-operating-channel.cc
--- ns-3.42/src/wifi/model/wifi-phy-operating-channel.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-phy-operating-channel.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Stefano Avallone <stavallo@unina.it>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
